// Copyright 2003 Regents of the University of California

// SETI_BOINC is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2, or (at your option) any later
// version.

// SETI_BOINC is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.

// You should have received a copy of the GNU General Public License along
// with SETI_BOINC; see the file COPYING.  If not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#define TEST_MIN_CHIRP_STEP 0.002776    // chirps .5 bins with 128K point FFT

// Variable (usually an array of such
// variables) to hold chirp/fft pairs.
typedef struct {
  float  ChirpRate;
  int   FftLen;
}
ChirpFftPair_t;

int GenChirpFftPairs(
  ChirpFftPair_t ** ChirpFftPairs,
  double * MinChirpStep
);

extern ChirpFftPair_t * ChirpFftPairs;
extern char * cfft_file;

void CalcChirpSteps(double* ChirpSteps, double* MinChirpStep);

bool VeryClose(double a, double b, double CloseEnough);

int ReadCFftFile(ChirpFftPair_t ** ChirpFftPairs, double * MinChirpStep);
